// start gantry

#declare gantryleg =
union {
    box {
        <0.0,-5,-0.5><0.5,0.0,0.5>
        matrix < 1, 0, 0,
                 0.4, 1, 0,
                 0, 0, 1,
                 0, 0, 0>
        }
    box {
        <0.0,-5,-0.5><0.5,0.0,0.5>
        matrix < 1, 0, 0,
                 0.5, 1, 0,
                 0, 0, 1,
                 0, 0, 0>
        }

    translate y*5
    scale inches}


#declare gantrymain =
union {
    box {
        <-3.0*inches, 4*inches, -0.5*inches>
        <3.0*inches, 5*inches, 0.5*inches>
        }
    box {
        <-0.3*inches,3.6*inches, -0.75*inches>
        <0.3*inches,4.1*inches, 0.4*inches>
         }
    box {
        <-0.25*inches,5*inches,-0.1*inches>
        <0.25*inches,5.2*inches,0.1*inches>
        }
    }

#declare gantry =
union {
    object {gantryleg
        translate x*-3*inches}
    object {gantryleg
        rotate y*180
        translate x*3*inches}
    object {gantrymain}

    texture {gantry_plastic}
    translate z*1*inches
    }

object{gantry}

#declare orange_start_light =
sphere {<0,0,0> 0.05*inches texture {pigment { colour rgb<1,0.5,0>} finish {phong 1.0}}}

#declare green_start_light =
sphere {<0,0,0> 0.05*inches texture {pigment { colour rgb<0,1,0>} finish {phong 1.0}}}

#declare red_start_light =
sphere {<0,0,0> 0.05*inches texture {pigment { colour rgb<1,0,0>} finish {phong 1.0}}}


#declare start_lights =
union{
    object {orange_start_light translate <-2.64*inches,4.25*inches,0.5*inches>}
    object {orange_start_light translate <-2.11*inches,4.25*inches,0.5*inches>}
    object {orange_start_light translate <-1.58*inches,4.25*inches,0.5*inches>}
    object {orange_start_light translate <-1.05*inches,4.25*inches,0.5*inches>}
    object {orange_start_light translate <-0.52*inches,4.25*inches,0.5*inches>}
    object {orange_start_light translate <0.52*inches,4.25*inches,0.5*inches>}
    object {orange_start_light translate <1.05*inches,4.25*inches,0.5*inches>}
    object {orange_start_light translate <1.58*inches,4.25*inches,0.5*inches>}
    object {orange_start_light translate <2.11*inches,4.25*inches,0.5*inches>}
    object {orange_start_light translate <2.64*inches,4.25*inches,0.5*inches>}
    object {red_start_light translate <-0.15*inches,3.725*inches,0.25*inches>}
    object {red_start_light translate <0.15*inches,3.725*inches,0.25*inches>}
    object {green_start_light translate <-0.15*inches,3.975*inches,0.25*inches>}
    object {green_start_light translate <0.15*inches,3.975*inches,0.25*inches>}

       }
object{start_lights}


#if (SCENE >= 1)
#if (SCENE <= 2)
    #declare effect_brightness = 1.25
    #declare effect_intensity = 0.75
    #declare effect_shrink = 1
    #declare glow_type = 1
    #declare glow_scale = <1,1,1>*0.4
    #declare rays_type = 2
    #declare rays_scale = <1,1,1>*0.4
    #declare streak_type = 4

    #declare effect_colour = <1.0, 0.5, 0.0>
    #declare source_colour = <1.0, 0.5, 0.0>
    #declare effect_scale = 25

#if (clock >= 119)
    #declare effect_location = <-2.64*inches,4.25*inches,0.5*inches>
    #include "LnsEfcts.inc"
    #declare effect_location = <2.64*inches,4.25*inches,0.5*inches>
    #include "LnsEfcts.inc"
    #end
#if (clock >= 134)
    #declare effect_location = <-2.11*inches,4.25*inches,0.5*inches>
    #include "LnsEfcts.inc"
    #declare effect_location = <2.11*inches,4.25*inches,0.5*inches>
    #include "LnsEfcts.inc"
    #end
#if (clock >= 149)
    #declare effect_location = <-1.58*inches,4.25*inches,0.5*inches>
    #include "LnsEfcts.inc"
    #declare effect_location = <1.58*inches,4.25*inches,0.5*inches>
    #include "LnsEfcts.inc"
    #end
#if (clock >= 164)
    #declare effect_location = <-1.05*inches,4.25*inches,0.5*inches>
    #include "LnsEfcts.inc"
    #declare effect_location = <1.05*inches,4.25*inches,0.5*inches>
    #include "LnsEfcts.inc"
    #end
#if (clock >= 179)
    #declare effect_location = <-0.52*inches,4.25*inches,0.5*inches>
    #include "LnsEfcts.inc"
    #declare effect_location = <0.52*inches,4.25*inches,0.5*inches>
    #include "LnsEfcts.inc"
    #end

#declare effect_colour = <0.0, 1.0, 0.0>
#declare source_colour = <0.0, 1.0, 0.0>
#declare effect_scale = 80

#if (clock >= 194)
    #declare effect_location = <-0.15*inches,3.975*inches,0.25*inches>
    #include "LnsEfcts.inc"
    #declare effect_location = <0.15*inches,3.975*inches,0.25*inches>
    #include "LnsEfcts.inc"
    #end

#declare effect_colour = <1.0, 0.0, 0.0>
#declare source_colour = <1.0, 0.0, 0.0>
#declare effect_scale = 60

#if (clock < 194)
    #declare effect_location = <-0.15*inches,3.725*inches,0.25*inches>
    #include "LnsEfcts.inc"
    #declare effect_location = <0.15*inches,3.725*inches,0.25*inches>
    #include "LnsEfcts.inc"
    #end

#end
#end
