// keyboard

#declare keyboard_base =
intersection{
    union {
        box {<-16.0,0.0,-12.0><16.0,2.0,-1.0>}
        box {<-18.5,0.0,-13.0><18.5,2.2,0.0> rotate x*-8 translate y*2.0}
        }
    box {<-16.3,1.75,-15.0><16.3,5.0,-7.0>inverse}
    box {<-10.6,4.0,-3.0><10.6,5.0,-0.8>inverse}
    texture {keyboard_plastic}
    }

#declare keyboard_button1 =
box {<-0.125,0.0,-0.15><0.125,0.1,0.15>}

#declare keyboard_button2 =
cylinder {<0.0,0.0,0.0><0.0,0.1,0.0>0.125}

#declare keyboard_button3 =
intersection{
    box {<-0.15,0.0,-0.15><0.15,0.1,0.15> rotate y*45}
    box {<-0.3,-0.1,-0.1><0.3,0.2,0.1> inverse}
    scale <1,1,1.5>
    }

#declare keyboard_panel =
union{
    union {
        object{ keyboard_button1 translate <-10.5,0.0,-5.5>}
        object{ keyboard_button1 translate <-2.25,0.0,-5.5>}
        object{ keyboard_button1 translate <4.75,0.0,-5.5>}
        texture{keyboard_button_red}
        }
    union {
        object{ keyboard_button1 translate <-9.5,0.0,-5.5>}
        object{ keyboard_button1 translate <-4.5,0.0,-5.5>}
        object{ keyboard_button1 translate <-3.5,0.0,-5.5>}
        object{ keyboard_button1 translate <-2.875,0.0,-5.5>}
        object{ keyboard_button1 translate <-1.25,0.0,-5.5>}
        object{ keyboard_button1 translate <2.75,0.0,-5.5>}
        object{ keyboard_button1 translate <5.25,0.0,-5.5>}
        object{ keyboard_button1 translate <5.875,0.0,-5.5>}
        object{ keyboard_button1 translate <6.5,0.0,-5.5>}
        object{ keyboard_button1 translate <7.0,0.0,-5.5>}
        object{ keyboard_button1 translate <9.0,0.0,-5.5>}
        texture{keyboard_button_black}
        }
    union {
        object{ keyboard_button3 translate <-7.0,0.0,-5.5>}
        object{ keyboard_button3 translate <-6.0,0.0,-5.5>}
        object{ keyboard_button3 translate <-5.0,0.0,-5.5>}
        object{ keyboard_button3 translate <3.75,0.0,-5.5>}
        object{ keyboard_button3 translate <8.25,0.0,-5.5>}

        object{ keyboard_button2 translate <-0.75,0.0,-4.75>}
        object{ keyboard_button2 translate <-0.75,0.0,-5.25>}
        object{ keyboard_button2 translate <-0.75,0.0,-5.75>}

        object{ keyboard_button2 translate <-0.0,0.0,-4.75>}
        object{ keyboard_button2 translate <-0.0,0.0,-5.25>}
        object{ keyboard_button2 translate <-0.0,0.0,-5.75>}

        object{ keyboard_button2 translate <0.75,0.0,-4.75>}
        object{ keyboard_button2 translate <0.75,0.0,-5.25>}
        object{ keyboard_button2 translate <0.75,0.0,-5.75>}

        object{ keyboard_button2 translate <1.5,0.0,-4.75>}
        object{ keyboard_button2 translate <1.5,0.0,-5.25>}
        object{ keyboard_button2 translate <1.5,0.0,-5.75>}
        texture{keyboard_button_grey}
        }

    object { keyboard_button1 translate <9.75, 0.0,-5.5> texture{keyboard_button_yellow}}
    box {<-9.0,0.0,-5.6><-7.5,0.1,-5.4> texture{keyboard_button_black}}

    box {<-2.0,0.0,-4.25><2.0,0.05,-2.5> texture{keyboard_screen}}
    box {<-16.5,0.0,-6.0><-11.0,0.1,-0.5> texture{speaker_plastic}}
    box {<11.0,0.0,-6.0><16.5,0.1,-0.5> texture{speaker_plastic}}


translate y*2.2 rotate x*-8 translate y*2.0
}

#declare white_key =
    box {<-0.4,2.2,-12.5><0.4,2.6,-7.1>}

#declare all_white_keys =
union{
    object {white_key translate x*-15.75 }
    object {white_key translate x*-14.85    }
    object {white_key translate x*-13.95    }
    object {white_key translate x*-13.05    }
    object {white_key translate x*-12.15    }
    object {white_key translate x*-11.25    }
    object {white_key translate x*-10.35    }
    object {white_key translate x*-9.45    }
    object {white_key translate x*-8.55    }
    object {white_key translate x*-7.65    }
    object {white_key translate x*-6.75    }
    object {white_key translate x*-5.85    }
    object {white_key translate x*-4.95    }
    object {white_key translate x*-4.05    }
    object {white_key translate x*-3.15    }
    object {white_key translate x*-2.25    }
    object {white_key translate x*-1.35    }
    object {white_key translate x*-0.45    }
    object {white_key translate x*15.75    }  // going back from end
    object {white_key translate x*14.85    }
    object {white_key translate x*13.95    }
    object {white_key translate x*13.05    }
    object {white_key translate x*12.15    }
    object {white_key translate x*11.25    }
    object {white_key translate x*10.35    }
    object {white_key translate x*9.45    }
    object {white_key translate x*8.55    }
    object {white_key translate x*7.65    }
    object {white_key translate x*6.75    }
    object {white_key translate x*5.85    }
    object {white_key translate x*4.95    }
    object {white_key translate x*4.05    }
    object {white_key translate x*3.15    }
    object {white_key translate x*2.25    }
    object {white_key translate x*1.35    }
    object {white_key translate x*0.45    }
    texture {keyboard_ivory}
    }

#declare black_key =
box {<-0.2, 2.0, -11.0><0.2,2.95,-7.0>}

#declare black_octave =
union {
    object {black_key translate x* -15.4}
    object {black_key translate x* -14.3}
    object {black_key translate x* -12.7}
    object {black_key translate x* -11.7}
    object {black_key translate x* -10.7}
    }

#declare all_black_keys =
union{
    object {black_octave translate x*0 }
    object {black_octave translate x*6.3   }
    object {black_octave translate x*12.6    }
    object {black_octave translate x*18.9    }
    object {black_octave translate x*25.2    }

    texture {keyboard_ebony}
    }



    #declare keyboard =
union {
    object{keyboard_base}
    object{all_white_keys}
    object{all_black_keys}
    object{keyboard_panel}
    scale inches
    }
